Index: /trunk/src/sys/arch/mips/mips/locore_mips1.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/locore_mips1.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/locore_mips1.S	(revision 152)
@@ -1018,341 +1674,105 @@
 	j	ra
 	nop
-END(mips1_wbflush)
+END(MIPSX(wbflush))
 #endif /* !ENABLE_MIPS_TX3900 */
 
-/*
- * mips1_lwp_trampoline
- *
- * Special arrangement for a process about to go user mode right after
- * fork() system call.  When the first CPU tick is scheduled to the
- * forked child, it starts running from here.  Then, a service function
- * is called with one argument supplied to complete final preparations,
- * and the process returns to user mode as if the fork() system call is
- * handled in a normal way.  No need to save any registers although this
- * calls another.
- */
-LEAF(mips1_lwp_trampoline)
-	addu	sp, sp, -CALLFRAME_SIZ
-
-	# Call lwp_startup(), with args from cpu_switchto()/cpu_setfunc()
-	la	t0, _C_LABEL(lwp_startup)
-	move	a0, v0
-	jal	ra, t0
-	move	a1, MIPS_CURLWP
-
-	# Call the routine specified by cpu_setfunc()
-	jal	ra, s0			
-	move	a0, s1
-
-	# Return to user (won't happen if a kernel thread)
-	.set	noat
-XLEAF(mips1_xcpt_return)
-	addu	a1, sp, CALLFRAME_SIZ	# a1 points exception frame
-	lw	a0, TF_REG_SR(a1)
-	lw	t0, TF_REG_MULLO(a1)
-	lw	t1, TF_REG_MULHI(a1)
-	mtc0	a0, MIPS_COP_0_STATUS	# this should disable interrupts
-	mtlo	t0
-	mthi	t1
-	nop
-	move	k1, a1
-	lw	k0, TF_REG_EPC(k1)
-	lw	AT, TF_REG_AST(k1)
-	lw	v0, TF_REG_V0(k1)
-	lw	v1, TF_REG_V1(k1)
-	lw	a0, TF_REG_A0(k1)
-	lw	a1, TF_REG_A1(k1)
-	lw	a2, TF_REG_A2(k1)
-	lw	a3, TF_REG_A3(k1)
-	lw	t0, TF_REG_T0(k1)
-	lw	t1, TF_REG_T1(k1)
-	lw	t2, TF_REG_T2(k1)
-	lw	t3, TF_REG_T3(k1)
-	lw	t4, TF_REG_T4(k1)
-	lw	t5, TF_REG_T5(k1)
-	lw	t6, TF_REG_T6(k1)
-	lw	t7, TF_REG_T7(k1)
-	lw	s0, TF_REG_S0(k1)
-	lw	s1, TF_REG_S1(k1)
-	lw	s2, TF_REG_S2(k1)
-	lw	s3, TF_REG_S3(k1)
-	lw	s4, TF_REG_S4(k1)
-	lw	s5, TF_REG_S5(k1)
-	lw	s6, TF_REG_S6(k1)
-	lw	s7, TF_REG_S7(k1)
-	lw	t8, TF_REG_T8(k1)
-	lw	t9, TF_REG_T9(k1)
-	lw	gp, TF_REG_GP(k1)
-	lw	s8, TF_REG_S8(k1)
-	lw	ra, TF_REG_RA(k1)
-	lw	sp, TF_REG_SP(k1)
-	nop
-	j	k0
-	rfe
-	.set	at
-END(mips1_lwp_trampoline)
-
-/*
- * Like lwp_trampoline, but do not call lwp_startup
- */
-LEAF(mips1_setfunc_trampoline)
-	addu	sp, sp, -CALLFRAME_SIZ
-
-	# Call the routine specified by cpu_setfunc()
-	jal	ra, s0			
-	move	a0, s1
-
-	j	mips1_xcpt_return
-	nop
-
-END(mips1_setfunc_trampoline)
-
-/*
- * void mips1_cpu_switch_resume(struct lwp *newlwp)
- *
- * Wiredown the USPACE of newproc with TLB entry#0 and #1.  Check
- * if target USPACE is already refered by any TLB entry before
- * doing that, and make sure TBIS(them) in the case.
- */
-LEAF_NOPROFILE(mips1_cpu_switch_resume)
-	lw	a1, L_MD_UPTE_0(a0)		# a1 = upte[0]
-	lw	a2, L_MD_UPTE_1(a0)		# a2 = upte[1]
-	lw	s0, L_ADDR(a0)			# va = l->l_addr
-	li	s2, VM_MIN_KERNEL_ADDRESS
-	blt	s0, s2, resume
-	nop
-
-	mtc0	s0, MIPS_COP_0_TLB_HI		# VPN = va
-	nop
-	tlbp					# probe 1st VPN
-	mfc0	s1, MIPS_COP_0_TLB_INDEX
-	nop
-	bltz	s1, entry0set
-	li	s1, MIPS_KSEG0_START		# found, then
-	mtc0	s1, MIPS_COP_0_TLB_HI
-	mtc0	zero, MIPS_COP_0_TLB_LOW
-	nop
-	tlbwi					# TBIS(va)
-	nop
-	mtc0	s0, MIPS_COP_0_TLB_HI		# set 1st VPN again
-entry0set:
-	mtc0	zero, MIPS_COP_0_TLB_INDEX	# TLB index #0
-	ori	a1, a1, MIPS1_PG_G
-	mtc0	a1, MIPS_COP_0_TLB_LOW		# 1st PFN w/ PG_G
-	nop
-	tlbwi					# set TLB entry #0
-
-	addu	s0, s0, PAGE_SIZE
-	mtc0	s0, MIPS_COP_0_TLB_HI		# VPN = va+PAGE_SIZE
-	nop
-	tlbp					# probe 2nd VPN
-	mfc0	s1, MIPS_COP_0_TLB_INDEX
-	nop
-	bltz	s1, entry1set
-	li	s1, MIPS_KSEG0_START		# found, then
-	mtc0	s1, MIPS_COP_0_TLB_HI
-	mtc0	zero, MIPS_COP_0_TLB_LOW
-	nop
-	tlbwi					# TBIS(va+PAGE_SIZE)
-	nop
-	mtc0	s0, MIPS_COP_0_TLB_HI		# set 2nd VPN again
-entry1set:
-	li	s1, 1 << MIPS1_TLB_INDEX_SHIFT
-	mtc0	s1, MIPS_COP_0_TLB_INDEX	# TLB index #1
-	ori	a2, a2, MIPS1_PG_G
-	mtc0	a2, MIPS_COP_0_TLB_LOW		# 2nd PFN w/ PG_G
-	nop
-	tlbwi					# set TLB entry #1
-
-resume:
-	j	ra
-	nop
-	END(mips1_cpu_switch_resume)
-
-/*
- * void mips1_tlb_invalidate_addr(vaddr_t va)
- *
- * Invalidate a TLB entry for given virtual address if found in TLB.
- */
-LEAF(mips1_tlb_invalidate_addr)
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
-	mfc0	t0, MIPS_COP_0_TLB_HI		# save current PID
-	nop
-
-	mtc0	a0, MIPS_COP_0_TLB_HI		# look for addr & PID
-	nop
-	tlbp					# probe the entry in question
-	mfc0	a0, MIPS_COP_0_TLB_INDEX	# see what we got
-	li	t1, MIPS_KSEG0_START		# load invalid address
-	bltz	a0, 1f				# index < 0 then skip
-	mtc0	t1, MIPS_COP_0_TLB_HI		# make entryHi invalid
-	mtc0	zero, MIPS_COP_0_TLB_LOW	# zero out entryLo
-	nop
-	tlbwi
-1:
-	mtc0	t0, MIPS_COP_0_TLB_HI		# restore PID
-	j	ra
-	mtc0	v1, MIPS_COP_0_STATUS		# restore the status register
-END(mips1_tlb_invalidate_addr)
-
-/*
- * void mips1_tlb_invalidate_asids(size_t sizeofTLB, uint32_t asid_lo,
- *	    uint32_t asid_hi)
- *
- * Invalidate TLB entries belonging to asids (asid_lo,asid_hi]
- * leaving entries for kernel space marked global intact.
- */
-LEAF(mips1_tlb_invalidate_asids)
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
-
-	li	t1, MIPS1_TLB_FIRST_RAND_ENTRY << MIPS1_TLB_INDEX_SHIFT
-	sll	t2, a0, MIPS1_TLB_INDEX_SHIFT
-	li	v0, MIPS_KSEG0_START		# invalid address
-
-	# do {} while (t1 < t2)
-1:
-	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set index
-	nop
-	tlbr					# obtain an entry
-	mfc0	ta0, MIPS_COP_0_TLB_LOW
-	nop
-	and	ta0, ta0, MIPS1_PG_G		# check to see it has G bit
-	bnez	ta0, 2f
-	 nop
-
-	mfc0	ta0, MIPS_COP_0_TLB_HI		# get va and ASID
-	nop
-	and	ta0, ta0, PG_ASID		# mask off ASID
-	sltu	ta1, ta0, a1			# < asid_lo
-	bnez	ta1, 2f				# yes, next tlb entry
-	 nop
-	sltu	ta2, ta0, a2			# < asid_hi
-	beqz	ta2, 2f				# no, next tlb entry
-	 nop
-
-	mtc0	v0, MIPS_COP_0_TLB_HI		# make entryHi invalid
-	mtc0	zero, MIPS_COP_0_TLB_LOW	# zero out entryLo
-	nop
-	tlbwi					# invalidate the TLB entry
-2:
-	addu	t1, t1, 1 << MIPS1_TLB_INDEX_SHIFT	# increment index
-	bne	t1, t2, 1b
-	nop
-
-	j	ra				# new TLBpid will be set soon
-	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
-END(mips1_tlb_invalidate_asids)
-
-/*
- * void mips1_tlb_invalidate_all(size_t sizeofTLB)
- *
- * Invalidate TLB entirely.
- */
-LEAF(mips1_tlb_invalidate_all)
-	mfc0	v1, MIPS_COP_0_STATUS		# save the status register.
-	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
-
-	li	t1, MIPS_KSEG0_START
-	mtc0	t1, MIPS_COP_0_TLB_HI		# make entryHi invalid
-	mtc0	zero, MIPS_COP_0_TLB_LOW	# zero out entryLo
-
-	move	t1, zero
-	sll	a0, a0, MIPS1_TLB_INDEX_SHIFT
-
-	# do {} while (t1 < a0)
-1:
-	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set TLBindex
-	addu	t1, t1, 1 << MIPS1_TLB_INDEX_SHIFT	# increment index
-	bne	t1, a0, 1b
-	tlbwi					# invalidate the entry
-
-	j	ra
-	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
-END(mips1_tlb_invalidate_all)
-
 	.rdata
 
-	.globl _C_LABEL(mips1_locoresw)
-_C_LABEL(mips1_locoresw):
-	.word _C_LABEL(mips1_cpu_switch_resume)
-	.word _C_LABEL(mips1_lwp_trampoline)
-	.word _C_LABEL(nullop)			# idle
-	.word _C_LABEL(mips1_setfunc_trampoline)
-	.word _C_LABEL(nullop)			# boot secondary processors
-	.word _C_LABEL(nullop)			# send ipi
-	.word _C_LABEL(nullop)			# spare
-	.word _C_LABEL(nullop)			# spare
-
-mips1_excpt_sw:
+	.globl _C_LABEL(MIPSX(locore_vec))
+_C_LABEL(MIPSX(locore_vec)):
+	PTR_WORD _C_LABEL(MIPSX(cpu_switch_resume))
+	PTR_WORD _C_LABEL(MIPSX(lwp_trampoline))
+	PTR_WORD _C_LABEL(MIPSX(setfunc_trampoline))
+	PTR_WORD _C_LABEL(MIPSX(wbflush))		# wbflush
+	PTR_WORD _C_LABEL(MIPSX(tlb_set_asid))
+	PTR_WORD _C_LABEL(MIPSX(tlb_invalidate_asids))
+	PTR_WORD _C_LABEL(MIPSX(tlb_invalidate_addr))
+	PTR_WORD _C_LABEL(nullop)			# tlb_invalidate_globals
+	PTR_WORD _C_LABEL(MIPSX(tlb_invalidate_all))
+	PTR_WORD _C_LABEL(MIPSX(tlb_record_asids))
+	PTR_WORD _C_LABEL(MIPSX(tlb_update))
+	PTR_WORD _C_LABEL(MIPSX(tlb_enter))
+	PTR_WORD _C_LABEL(MIPSX(tlb_read_indexed))
+	PTR_WORD _C_LABEL(MIPSX(tlb_write_indexed))
+
+	.globl _C_LABEL(MIPSX(locoresw))
+_C_LABEL(MIPSX(locoresw)):
+	PTR_WORD _C_LABEL(MIPSX(wbflush))		# lsw_wbflush
+	PTR_WORD _C_LABEL(nullop)			# lsw_cpu_idle
+	PTR_WORD _C_LABEL(nullop)			# lsw_send_ipi
+	PTR_WORD _C_LABEL(nullop)			# lsw_cpu_offline_md
+	PTR_WORD _C_LABEL(nullop)			# lsw_cpu_init
+	PTR_WORD _C_LABEL(nullop)			# lsw_cpu_run
+	PTR_WORD _C_LABEL(nullop)			# lsw_bus_error
+
+MIPSX(excpt_sw):
 	####
 	#### The kernel exception handlers.
 	####
-	.word _C_LABEL(mips1_kern_intr)		# 0 external interrupt
-	.word _C_LABEL(mips1_kern_gen_exception)# 1 TLB modification
-	.word _C_LABEL(mips1_tlb_miss_exception)# 2 TLB miss (LW/I-fetch)
-	.word _C_LABEL(mips1_tlb_miss_exception)# 3 TLB miss (SW)
-	.word _C_LABEL(mips1_kern_gen_exception)# 4 address error (LW/I-fetch)
-	.word _C_LABEL(mips1_kern_gen_exception)# 5 address error (SW)
-	.word _C_LABEL(mips1_kern_gen_exception)# 6 bus error (I-fetch)
-	.word _C_LABEL(mips1_kern_gen_exception)# 7 bus error (load or store)
-	.word _C_LABEL(mips1_kern_gen_exception)# 8 system call
-	.word _C_LABEL(mips1_kern_gen_exception)# 9 breakpoint
-	.word _C_LABEL(mips1_kern_gen_exception)# 10 reserved instruction
-	.word _C_LABEL(mips1_kern_gen_exception)# 11 coprocessor unusable
-	.word _C_LABEL(mips1_kern_gen_exception)# 12 arithmetic overflow
-	.word _C_LABEL(mips1_kern_gen_exception)# 13 r3k reserved
-	.word _C_LABEL(mips1_kern_gen_exception)# 14 r3k reserved
-	.word _C_LABEL(mips1_kern_gen_exception)# 15 r3k reserved
-	.word _C_LABEL(mips1_kern_gen_exception)# 16 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 17 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 18 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 19 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 20 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 21 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 22 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 23 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 24 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 25 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 26 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 27 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 28 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 29 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 30 never happens w/ MIPS1
-	.word _C_LABEL(mips1_kern_gen_exception)# 31 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_intr))	# 0 external interrupt
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 1 TLB modification
+	PTR_WORD _C_LABEL(MIPSX(kern_tlb_miss))	# 2 TLB miss (LW/I-fetch)
+	PTR_WORD _C_LABEL(MIPSX(kern_tlb_miss))	# 3 TLB miss (SW)
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 4 address error (LW/I-fetch)
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 5 address error (SW)
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 6 bus error (I-fetch)
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 7 bus error (load or store)
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 8 system call
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 9 breakpoint
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 10 reserved instruction
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 11 coprocessor unusable
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 12 arithmetic overflow
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 13 r3k reserved
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 14 r3k reserved
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 15 r3k reserved
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 16 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 17 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 18 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 19 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 20 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 21 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 22 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 23 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 24 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 25 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 26 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 27 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 28 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 29 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 30 never happens w/ MIPS1
+	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))# 31 never happens w/ MIPS1
 	#####
 	##### The user exception handlers.
 	#####
-	.word _C_LABEL(mips1_user_intr)		#  0
-	.word _C_LABEL(mips1_user_gen_exception)#  1
-	.word _C_LABEL(mips1_user_gen_exception)#  2
-	.word _C_LABEL(mips1_user_gen_exception)#  3
-	.word _C_LABEL(mips1_user_gen_exception)#  4
-	.word _C_LABEL(mips1_user_gen_exception)#  5
-	.word _C_LABEL(mips1_user_gen_exception)#  6
-	.word _C_LABEL(mips1_user_gen_exception)#  7
-	.word _C_LABEL(mips1_systemcall)	#  8
-	.word _C_LABEL(mips1_user_gen_exception)#  9
-	.word _C_LABEL(mips1_user_gen_exception)# 10
-	.word _C_LABEL(mips1_user_gen_exception)# 11
-	.word _C_LABEL(mips1_user_gen_exception)# 12
-	.word _C_LABEL(mips1_user_gen_exception)# 13
-	.word _C_LABEL(mips1_user_gen_exception)# 14
-	.word _C_LABEL(mips1_user_gen_exception)# 15
-	.word _C_LABEL(mips1_user_gen_exception)# 16
-	.word _C_LABEL(mips1_user_gen_exception)# 17
-	.word _C_LABEL(mips1_user_gen_exception)# 18
-	.word _C_LABEL(mips1_user_gen_exception)# 19
-	.word _C_LABEL(mips1_user_gen_exception)# 20
-	.word _C_LABEL(mips1_user_gen_exception)# 21
-	.word _C_LABEL(mips1_user_gen_exception)# 22
-	.word _C_LABEL(mips1_user_gen_exception)# 23
-	.word _C_LABEL(mips1_user_gen_exception)# 24
-	.word _C_LABEL(mips1_user_gen_exception)# 25
-	.word _C_LABEL(mips1_user_gen_exception)# 26
-	.word _C_LABEL(mips1_user_gen_exception)# 27
-	.word _C_LABEL(mips1_user_gen_exception)# 28
-	.word _C_LABEL(mips1_user_gen_exception)# 29
-	.word _C_LABEL(mips1_user_gen_exception)# 20
-	.word _C_LABEL(mips1_user_gen_exception)# 31
+	PTR_WORD _C_LABEL(MIPSX(user_intr))	#  0
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))#  1
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))#  2
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))#  3
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))#  4
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))#  5
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))#  6
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))#  7
+	PTR_WORD _C_LABEL(MIPSX(systemcall))	#  8
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))#  9
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 10
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 11
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 12
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 13
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 14
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 15
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 16
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 17
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 18
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 19
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 20
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 21
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 22
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 23
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 24
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 25
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 26
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 27
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 28
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 29
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 20
+	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))# 31
Index: /trunk/src/sys/arch/mips/mips/locore_mips3.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/locore_mips3.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/locore_mips3.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: locore_mips3.S,v 1.93.38.9 2010/05/14 22:26:00 matt Exp $	*/
+/*	locore_mips3.S,v 1.93.38.12 2011/04/29 08:26:26 matt Exp	*/
 
 /*
@@ -111,9 +111,4 @@
  *	tlbp		-- one integer op afterwards
  * Obvious solution is to take least common denominator.
- *
- * For the Toshiba R5900, TX79:
- *	mtc0		following sync.p
- *	tlbw[ri], tlbp	following sync.p or eret
- * for those CPU, define COP0_SYNC as sync.p
  */
 
@@ -130,4 +125,12 @@
 	.set	mips3
 
+#ifdef _LP64
+#define	_MFC0	dmfc0
+#define	_MTC0	dmtc0
+#else
+#define	_MFC0	mfc0
+#define	_MTC0	mtc0
+#endif
+
 	.text
 
@@ -149,16 +152,17 @@
  */
 LEAF(mips3_wbflush)
-XLEAF(mips5900_wbflush)
 XLEAF(mips32_wbflush)
+XLEAF(mips32r2_wbflush)
 XLEAF(mips64_wbflush)
+XLEAF(mips64r2_wbflush)
+XLEAF(mips64_rmixl_wbflush)
+XLEAF(mips64r2_rmixl_wbflush)
 	nop
 	sync
 	j	ra
-	nop
+	 nop
 END(mips3_wbflush)
 
 
-/* XXX simonb: ugg, another ugly #ifdef check... */
-#if (defined(MIPS3) && !defined(MIPS3_5900)) || defined(MIPS32) || defined(MIPS64)
 /*
  * mips_wait_idle:
@@ -171,10 +175,11 @@
 	andi	v1, v0, MIPS_SR_INT_IE
 	beqz	v1, 1f
-	nop
+	 nop
 	andi	v1, v0, MIPS_INT_MASK
 	bnez	v1, 2f
-	nop
+	 nop
 1:
-	PANIC("mips_wait_idle: interrupts disabled")
+	move	a1, v0
+	PANIC("mips_wait_idle: interrupts disabled status=%#x")
 
 2:	wait
@@ -183,7 +188,6 @@
 	nop
 	j	ra
-	nop
+	 nop
 END(mips_wait_idle)
-#endif /* (MIPS3 && !MIPS3_5900) || MIPS32 || MIPS64 */
 
 /*
@@ -195,5 +199,5 @@
 	mfc0	v0, MIPS_COP_0_COMPARE
 	j	ra
-	nop
+	 nop
 END(mips3_cp0_compare_read)
 
@@ -205,9 +209,5 @@
 LEAF(mips3_cp0_compare_write)
 	mtc0	a0, MIPS_COP_0_COMPARE
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	nop
+	JR_HB_RA
 END(mips3_cp0_compare_write)
 
@@ -220,5 +220,5 @@
 	mfc0	v0, MIPS_COP_0_CONFIG
 	j	ra
-	nop
+	 nop
 END(mips3_cp0_config_read)
 
@@ -230,12 +230,14 @@
 LEAF(mips3_cp0_config_write)
 	mtc0	a0, MIPS_COP_0_CONFIG
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	nop
+	JR_HB_RA
 END(mips3_cp0_config_write)
 
-#if defined(MIPS32) || defined(MIPS64)
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	.set push
+#ifdef _LP64
+	.set mips64
+#else
+	.set mips32
+#endif
 /*
  * uint32_t mipsNN_cp0_config1_read(void)
@@ -244,10 +246,7 @@
  */
 LEAF(mipsNN_cp0_config1_read)
-	.set push
-	.set mips32
 	mfc0	v0, MIPS_COP_0_CONFIG, 1
 	j	ra
-	nop
-	.set pop
+	 nop
 END(mipsNN_cp0_config1_read)
 
@@ -255,14 +254,9 @@
  * uint32_t mipsNN_cp0_config1_write(uint32_t)
  *
- *	Return the current value of the CP0 Config (Select 1) register.
+ *	Set the current value of the CP0 Config (Select 1) register.
  */
 LEAF(mipsNN_cp0_config1_write)
-	.set push
-	.set mips32
 	mtc0	v0, MIPS_COP_0_CONFIG, 1
-	nop
-	j	ra
-	nop
-	.set pop
+	JR_HB_RA
 END(mipsNN_cp0_config1_write)
 
@@ -273,10 +267,7 @@
  */
 LEAF(mipsNN_cp0_config2_read)
-	.set push
-	.set mips32
 	mfc0	v0, MIPS_COP_0_CONFIG, 2
 	j	ra
-	nop
-	.set pop
+	 nop
 END(mipsNN_cp0_config2_read)
 
@@ -287,12 +278,150 @@
  */
 LEAF(mipsNN_cp0_config3_read)
-	.set push
-	.set mips32
 	mfc0	v0, MIPS_COP_0_CONFIG, 3
 	j	ra
-	nop
-	.set pop
+	 nop
 END(mipsNN_cp0_config3_read)
-#endif /* MIPS32 || MIPS64 */
+
+/*
+ * uintptr_t mipsNN_cp0_watchlo_read(u_int sel)
+ *
+ *	Return the current value of the selected CP0 Watchlo register.
+ */
+LEAF(mipsNN_cp0_watchlo_read)
+	sll	a0, 2
+	PTR_LA	t9, 1f
+	PTR_ADDU t9, a0
+	jr	t9
+	 nop
+1:
+	jr	ra
+	 _MFC0	v0, MIPS_COP_0_WATCH_LO, 0
+	jr	ra
+	 _MFC0	v0, MIPS_COP_0_WATCH_LO, 1
+	jr	ra
+	 _MFC0	v0, MIPS_COP_0_WATCH_LO, 2
+	jr	ra
+	 _MFC0	v0, MIPS_COP_0_WATCH_LO, 3
+	jr	ra
+	 _MFC0	v0, MIPS_COP_0_WATCH_LO, 4
+	jr	ra
+	 _MFC0	v0, MIPS_COP_0_WATCH_LO, 5
+	jr	ra
+	 _MFC0	v0, MIPS_COP_0_WATCH_LO, 6
+	jr	ra
+	 _MFC0	v0, MIPS_COP_0_WATCH_LO, 7
+END(mipsNN_cp0_watchlo_read)
+
+/*
+ * void mipsNN_cp0_watchlo_write(u_int sel, uintptr_t val)
+ *
+ *	Set the current value of the selected CP0 WatchLo register.
+ */
+LEAF(mipsNN_cp0_watchlo_write)
+	sll	a0, 2
+	PTR_LA	t9, 1f
+	PTR_ADDU t9, a0
+	jr	t9
+	 nop
+1:
+	jr	ra
+	 _MTC0	a1, MIPS_COP_0_WATCH_LO, 0
+	jr	ra
+	 _MTC0	a1, MIPS_COP_0_WATCH_LO, 1
+	jr	ra
+	 _MTC0	a1, MIPS_COP_0_WATCH_LO, 2
+	jr	ra
+	 _MTC0	a1, MIPS_COP_0_WATCH_LO, 3
+	jr	ra
+	 _MTC0	a1, MIPS_COP_0_WATCH_LO, 4
+	jr	ra
+	 _MTC0	a1, MIPS_COP_0_WATCH_LO, 5
+	jr	ra
+	 _MTC0	a1, MIPS_COP_0_WATCH_LO, 6
+	jr	ra
+	 _MTC0	a1, MIPS_COP_0_WATCH_LO, 7
+END(mipsNN_cp0_watchlo_write)
+
+/*
+ * uint32_t mipsNN_cp0_watchhi_read(u_int sel)
+ *
+ *	Return the current value of the selected CP0 WatchHi register.
+ */
+LEAF(mipsNN_cp0_watchhi_read)
+	sll	a0, 2
+	PTR_LA	t9, 1f
+	PTR_ADDU t9, a0
+	jr	t9
+	 nop
+1:
+	jr	ra
+	 mfc0	v0, MIPS_COP_0_WATCH_HI, 0
+	jr	ra
+	 mfc0	v0, MIPS_COP_0_WATCH_HI, 1
+	jr	ra
+	 mfc0	v0, MIPS_COP_0_WATCH_HI, 2
+	jr	ra
+	 mfc0	v0, MIPS_COP_0_WATCH_HI, 3
+	jr	ra
+	 mfc0	v0, MIPS_COP_0_WATCH_HI, 4
+	jr	ra
+	 mfc0	v0, MIPS_COP_0_WATCH_HI, 5
+	jr	ra
+	 mfc0	v0, MIPS_COP_0_WATCH_HI, 6
+	jr	ra
+	 mfc0	v0, MIPS_COP_0_WATCH_HI, 7
+END(mipsNN_cp0_watchhi_read)
+
+/*
+ * void mipsNN_cp0_watchhi_write(u_int sel, uint32_t val)
+ *
+ *	Set the current value of the selected CP0 WatchHi register.
+ */
+LEAF(mipsNN_cp0_watchhi_write)
+	sll	a0, 2
+	PTR_LA	t9, 1f
+	PTR_ADDU t9, a0
+	jr	t9
+	 nop
+1:
+	jr	ra
+	 mtc0	a1, MIPS_COP_0_WATCH_HI, 0
+	jr	ra
+	 mtc0	a1, MIPS_COP_0_WATCH_HI, 1
+	jr	ra
+	 mtc0	a1, MIPS_COP_0_WATCH_HI, 2
+	jr	ra
+	 mtc0	a1, MIPS_COP_0_WATCH_HI, 3
+	jr	ra
+	 mtc0	a1, MIPS_COP_0_WATCH_HI, 4
+	jr	ra
+	 mtc0	a1, MIPS_COP_0_WATCH_HI, 5
+	jr	ra
+	 mtc0	a1, MIPS_COP_0_WATCH_HI, 6
+	jr	ra
+	 mtc0	a1, MIPS_COP_0_WATCH_HI, 7
+END(mipsNN_cp0_watchhi_write)
+
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+/*
+ * void mipsNN_cp0_userlocal_write(void *);
+ *	Set the value of the CP0 USERLOCAL (TLB_CONTEXT, select 2) register.
+ */
+LEAF(mipsNN_cp0_hwrena_write)
+	j	ra
+	 mtc0	a0, MIPS_COP_0_HWRENA
+END(mipsNN_cp0_hwrena_write)
+
+/*
+ * void mipsNN_cp0_userlocal_write(void *);
+ *	Set the value of the CP0 USERLOCAL (TLB_CONTEXT, select 2) register.
+ */
+LEAF(mipsNN_cp0_userlocal_write)
+	j	ra
+	 _MTC0	a0, MIPS_COP_0_TLB_CONTEXT, 2
+END(mipsNN_cp0_userlocal_write)
+#endif /* (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0 */
+	.set	pop
+#endif /* (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
 
 /*
@@ -304,5 +433,5 @@
 	mfc0	v0, MIPS_COP_0_COUNT
 	j	ra
-	nop
+	 nop
 END(mips3_cp0_count_read)
 WEAK_ALIAS(cpu_counter32, mips3_cp0_count_read)
@@ -315,9 +444,5 @@
 LEAF(mips3_cp0_count_write)
 	mtc0	a0, MIPS_COP_0_COUNT
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	nop
+	JR_HB_RA
 END(mips3_cp0_count_write)
 
@@ -330,5 +455,5 @@
 	mfc0	v0, MIPS_COP_0_TLB_WIRED
 	j	ra
-	nop
+	 nop
 END(mips3_cp0_wired_read)
 
@@ -340,9 +465,5 @@
 LEAF(mips3_cp0_wired_write)
 	mtc0	a0, MIPS_COP_0_TLB_WIRED
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	nop
+	JR_HB_RA
 END(mips3_cp0_wired_write)
 
@@ -354,9 +475,5 @@
 LEAF(mips3_cp0_pg_mask_write)
 	mtc0	a0, MIPS_COP_0_TLB_PG_MASK
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	nop
+	JR_HB_RA
 END(mips3_cp0_pg_mask_write)
 
@@ -367,7 +484,4 @@
 	mtc0	t1, MIPS_COP_0_STATUS
 	COP0_SYNC
-	nop
-	nop
-	nop
 
 	ld	v0, 0(a0)
@@ -388,12 +502,10 @@
 
 	mtc0	t0, MIPS_COP_0_STATUS		# restore intr status.
-	COP0_SYNC
-	nop
+	JR_HB_RA
 #else /* !__mips_o32 */
 	ld	v0, 0(a0)
+	jr	ra
+	 nop
 #endif /* !__mips_o32 */
-
-	jr	ra
-	nop
 END(mips3_ld)
 
@@ -404,7 +516,4 @@
 	mtc0	t1, MIPS_COP_0_STATUS
 	COP0_SYNC
-	nop
-	nop
-	nop
 
 #if defined(_MIPS_BSD_API) && \
@@ -428,12 +537,11 @@
 
 	mtc0	t0, MIPS_COP_0_STATUS		# restore intr status.
-	COP0_SYNC
-	nop
+	JR_HB_RA
 #else /* !__mips_o32 */
 	sd	a1, 0(a0)
+	jr	ra
+	 nop
 #endif /* !__mips_o32 */
 
-	jr	ra
-	nop
 END(mips3_sd)
 
@@ -444,5 +552,5 @@
  */
 LEAF(badaddr64)
-	PTR_L	v1, L_ADDR(MIPS_CURLWP)
+	PTR_L	v1, L_PCB(MIPS_CURLWP)
 	PTR_LA	v0, _C_LABEL(baderr64)
 
@@ -472,17 +580,17 @@
 
 	bne	a1, 1, 2f
-	PTR_S	v0, U_PCB_ONFAULT(v1)
+	 PTR_S	v0, PCB_ONFAULT(v1)
 	b	9f
-	lbu	v0, (a0)
+	 lbu	v0, (a0)
 2:
 	bne	a1, 2, 4f
-	nop
+	 nop
 	b	9f
-	lhu	v0, (a0)
+	 lhu	v0, (a0)
 4:
 	bne	a1, 4, 8f
-	nop
+	 nop
 	b	9f
-	INT_L	v0, (a0)
+	 INT_L	v0, (a0)
 8:
 	REG_L	v0, (a0)
@@ -491,9 +599,7 @@
 	mtc0	t0, MIPS_COP_0_STATUS           # Restore KX
 	COP0_SYNC
-	nop
-	nop
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	move	v0, zero			# made it w/o errors
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 move	v0, zero			# made it w/o errors
 END(badaddr64)
 
@@ -501,7 +607,7 @@
 	mtc0	t0, MIPS_COP_0_STATUS		# Restore KX
 	COP0_SYNC
-	PTR_S	zero, U_PCB_ONFAULT(v1)
-	j	ra
-	li	v0, -1
+	PTR_S	zero, PCB_ONFAULT(v1)
+	j	ra
+	 li	v0, -1
 END(baderr64)
 
@@ -519,6 +625,4 @@
 	dmtc0	v0, MIPS_COP_0_TLB_HI
 	COP0_SYNC
-	nop
-	nop
 	dmfc0	v0, MIPS_COP_0_TLB_HI
 	dmtc0	t0, MIPS_COP_0_TLB_HI
@@ -551,12 +655,8 @@
 	dmtc0	v0, MIPS_COP_0_TLB_LO0
 	COP0_SYNC
-	nop
-	nop
 	dmfc0	v0, MIPS_COP_0_TLB_LO0
 	dmtc0	t0, MIPS_COP_0_TLB_LO0
 	COP0_SYNC
-	nop
 #ifdef __mips_o32
-	nop
 #if BYTE_ORDER == BIG_ENDIAN
 	srl	v1, v0, 0
@@ -584,12 +684,7 @@
 	mtc0	v0, MIPS_COP_0_TLB_PG_MASK
 	COP0_SYNC
-	nop
-	nop
 	mfc0	v0, MIPS_COP_0_TLB_PG_MASK
 	mtc0	t0, MIPS_COP_0_TLB_PG_MASK
-	COP0_SYNC
-	nop
-	j	ra
-	 nop
+	JR_HB_RA
 END(mips3_cp0_tlb_page_mask_probe)
 
@@ -614,5 +709,5 @@
 
 #ifdef _LP64
-	li	v0, MIPS_SR_KX			# allow 64bit addressing
+	li	v0, MIPS_SR_KX | MIPS_SR_UX	# allow 64bit addressing
 #else
 	li	v0, 0
Index: /trunk/src/sys/arch/mips/mips/mem.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mem.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mem.c	(revision 152)
@@ -1,5 +1,6 @@
-/*	$NetBSD: mem.c,v 1.35.38.5 2010/01/26 21:19:25 matt Exp $	*/
+/*	$NetBSD: mem.c,v 1.35.38.6 2011/04/29 08:26:27 matt Exp $	*/
 
 /*
+ * Copyright (c) 1988 University of Utah.
  * Copyright (c) 1982, 1986, 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -35,41 +36,4 @@
  *	@(#)mem.c	8.3 (Berkeley) 1/12/94
  */
-/*
- * Copyright (c) 1988 University of Utah.
- *
- * This code is derived from software contributed to Berkeley by
- * the Systems Programming Group of the University of Utah Computer
- * Science Department and Ralph Campbell.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- *	@(#)mem.c	8.3 (Berkeley) 1/12/94
- */
 
 /*
@@ -81,5 +45,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mem.c,v 1.35.38.5 2010/01/26 21:19:25 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: mem.c,v 1.35.38.6 2011/04/29 08:26:27 matt Exp $");
 
 #include <sys/param.h>
@@ -120,8 +84,5 @@
 /*ARGSUSED*/
 int
-mmrw(dev, uio, flags)
-	dev_t dev;
-	struct uio *uio;
-	int flags;
+mmrw(dev_t dev, struct uio *uio, int flags)
 {
 	vaddr_t v;
@@ -164,5 +125,20 @@
 			v = uio->uio_offset;
 			c = min(iov->iov_len, MAXPHYS);
-			if (v < MIPS_KSEG0_START)
+#ifdef _LP64
+			if (v < MIPS_XKPHYS_START) {
+				return (EFAULT);
+			} else if (MIPS_XKPHYS_P(v)
+			    && v > MIPS_PHYS_TO_XKPHYS_CACHED(mips_avail_end +
+					mips_round_page(MSGBUFSIZE) - c)) {
+				return (EFAULT);
+			} else if (MIPS_XKSEG_P(v)
+			    && v < MIPS_KSEG0_START
+			    && !uvm_kernacc((void *)v, c,
+			    uio->uio_rw == UIO_READ ? B_READ : B_WRITE)) {
+				return (EFAULT);
+			} else if (MIPS_KSEG1_P(v) || MIPS_KSEG2_P(v)) {
+				return (EFAULT);
+			}
+#else
 			if (v < MIPS_KSEG0_START)
 				return (EFAULT);
@@ -173,4 +149,5 @@
 			    uio->uio_rw == UIO_READ ? B_READ : B_WRITE)))
 				return (EFAULT);
+#endif
 			error = uiomove((void *)v, c, uio);
 #if defined(MIPS3_PLUS) && !defined(TSAR)
Index: /trunk/src/sys/arch/mips/mips/mips32_subr.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips32_subr.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips32_subr.S	(revision 152)
@@ -1,14 +1,13 @@
-/*	$NetBSD: mips32_subr.S,v 1.3.96.1 2010/01/16 20:56:33 matt Exp $	*/
+/*	mips32_subr.S,v 1.3.96.2 2011/04/29 08:26:27 matt Exp	*/
 
 #undef MIPS1
 #undef MIPS3
 /* #undef MIPS32 */
+#undef MIPS32R2
 #undef MIPS64
+#undef MIPS64R2
 #undef MIPS64_SB1
-#undef MIPS64_XLP
-#undef MIPS64_XLR
-#undef MIPS64_XLS
-
-#undef MIPS3_5900
+#undef MIPS64R2_RMIXL
+#undef MIPS64_RMIXL
 
 #include <mips/mips/mipsX_subr.S>
Index: /trunk/src/sys/arch/mips/mips/mips32r2_subr.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips32r2_subr.S	(revision 152)
+++ /trunk/src/sys/arch/mips/mips/mips32r2_subr.S	(revision 152)
@@ -0,0 +1,13 @@
+/*	mips32r2_subr.S,v 1.1.4.2 2011/04/29 08:26:27 matt Exp	*/
+
+#undef MIPS1
+#undef MIPS3
+#undef MIPS32
+/* #undef MIPS32R2 */
+#undef MIPS64
+#undef MIPS64R2
+#undef MIPS64_SB1
+#undef MIPS64R2_RMIXL
+#undef MIPS64_RMIXL
+
+#include <mips/mips/mipsX_subr.S>
